# Raumplaner-Anfangsprojekt.py
# Anfangsprojekt ohne Kapselung (in Stuhl und Tisch)
# Hier ist Persistenz und Speichern des Bilds moeglich

from grafikfenster import *

from stuhl import Stuhl
from tisch import Tisch

import sys

import pickle

### ---------------------------------------------------
class RaumplanerApp(wx.App):
    """Testanwendung fuer Raumplaner-Grafik
       ShellFrame: Interaktion mit laufender Anwendung
       FillingFrame: Anzeige der Umgebung"""
    def OnInit(self):
        self.fenster = GrafikFenster(None, "Raumplaner-Grafik")
        self.SetTopWindow(self.fenster)
        self.fenster.Show(True)
        self.fenster.panel.Refresh()
        self.fenster.ZeigeShellFrame()
        #self.fenster.ZeigeFillingFrame()
        #self.TestAnwendung()
        Stuhl.SetzeApp(self)
        Tisch.SetzeApp(self)
        self.objekte = []
        return True

    def TestAnwendung(self):
        """Allein fuer die Testanwendung:"""
        global tisch, stuhl
        tisch=Tisch(True)
        stuhl=Stuhl(True)

    def NeuesObjekt(self, objekt):
        self.objekte.append(objekt)

    def Oeffnen(self):
        self.objekte = []
        try:
            with open('daten.dat', 'rb') as objekt_datei:
                self.objekte = pickle.load(objekt_datei)
                for objekt in self.objekte: objekt.Zeige()
        except IOError:
            print('Datei nicht auffindbar!')
        except ImportError as impErr:
            print('Import-Fehler: ' + str(impErr))
        except pickle.UnpicklingError as perr:
            print('Pickle-Fehler: ' + str(perr))
        

    def Speichern(self):
        try:
            with open('daten.dat', 'wb') as objekt_datei:
                pickle.dump(self.objekte, objekt_datei)
        except IOError as ioerr:
            print('Dateifehler: ' + str(ioerr))
        except pickle.PicklingError as perr:
            print('Pickle-Fehler: ' + str(perr))

    def BildExport(self, dateiname="Bild.png"):
        Zeichenflaeche.GibZeichenflaeche().BildExport(dateiname)

### ---------------------------------------------------
if __name__ == '__main__':
    app = RaumplanerApp(redirect=False)
    # Parameterwert True, wenn Ausgaben in der Standard E/A angezeigt werden sollen
    app.MainLoop()
